Draft WireToBSpline: Difference between revisions

From FreeCAD Documentation
(Image caption; translate tags in correct location)
(Marked this version for translation)
Line 17: Line 17:
[[Image:Draft Wire2BSpline example.jpg|400px]]
[[Image:Draft Wire2BSpline example.jpg|400px]]
<translate>
<translate>
<!--T:12-->
{{Caption|Convertir a wire to a B-Spline, and a closed B-Spline to a closed wire}}
{{Caption|Convertir a wire to a B-Spline, and a closed B-Spline to a closed wire}}


Line 25: Line 26:
# Press the {{Button|[[Image:Draft WireToBSpline.svg|16px]] [[Draft WireToBSpline]]}} button.
# Press the {{Button|[[Image:Draft WireToBSpline.svg|16px]] [[Draft WireToBSpline]]}} button.


<!--T:13-->
A new object will be created; the original object will not be modified.
A new object will be created; the original object will not be modified.


<!--T:14-->
{{Emphasis|Note:}} if a closed wire with sharp edges is used to create a spline, the new object may have self intersecting curve segments, and may not be visible in the 3D view. If this is the case, manually set {{PropertyData|Make Face}} to {{FALSE}} to see the new shape, or set {{PropertyData|Closed}} to {{FALSE}} to create an open shape.
{{Emphasis|Note:}} if a closed wire with sharp edges is used to create a spline, the new object may have self intersecting curve segments, and may not be visible in the 3D view. If this is the case, manually set {{PropertyData|Make Face}} to {{FALSE}} to see the new shape, or set {{PropertyData|Closed}} to {{FALSE}} to create an open shape.


Line 40: Line 43:
There is no programming interface available for the WireToBSpline tool; however, creating a new object from the points of another is simple.
There is no programming interface available for the WireToBSpline tool; however, creating a new object from the points of another is simple.


<!--T:15-->
The {{incode|Points}} attribute of an object is a list with the points that comprise that object; this list can be passed to functions that build geometry. Each point is defined by its {{incode|FreeCAD.Vector}}, with units in millimeters.
The {{incode|Points}} attribute of an object is a list with the points that comprise that object; this list can be passed to functions that build geometry. Each point is defined by its {{incode|FreeCAD.Vector}}, with units in millimeters.


Line 67: Line 71:
<translate>
<translate>


<!--T:16-->
{{Draft Tools navi}}
{{Draft Tools navi}}
{{Userdocnavi}}
{{Userdocnavi}}

Revision as of 13:00, 8 January 2019

Draft WireToBSpline

Menu location
Drafting → Wire to BSpline
Workbenches
Draft, Arch
Default shortcut
None
Introduced in version
-
See also
Draft Wire, Draft BSpline

Description

This tool converts Draft Wires to Draft BSplines, and vice-versa.

Convertir a wire to a B-Spline, and a closed B-Spline to a closed wire

How to use

  1. Select a Draft Wire or a Draft BSpline. The tool is disabled if no object is selected.
  2. Press the Draft WireToBSpline button.

A new object will be created; the original object will not be modified.

Note: if a closed wire with sharp edges is used to create a spline, the new object may have self intersecting curve segments, and may not be visible in the 3D view. If this is the case, manually set DataMake Face to false to see the new shape, or set DataClosed to false to create an open shape.

Options

There are no options for this tool. Either it works with the selected object or not.

Scripting

See also: Draft API and FreeCAD Scripting Basics.

There is no programming interface available for the WireToBSpline tool; however, creating a new object from the points of another is simple.

The Points attribute of an object is a list with the points that comprise that object; this list can be passed to functions that build geometry. Each point is defined by its FreeCAD.Vector, with units in millimeters.

Example:

import FreeCAD, Draft

# Make a spline from the points of a wire
p1 = FreeCAD.Vector(1000, 1000, 0)
p2 = FreeCAD.Vector(2000, 1000, 0)
p3 = FreeCAD.Vector(2500, -1000, 0)
p4 = FreeCAD.Vector(3500, -500, 0)

base_wire = Draft.makeWire([p1, p2, p3, p4])

points1 = base_wire.Points
spline = Draft.makeBSpline(points1)

# Make a wire from the points of a spline
base_spline = Draft.makeBSpline([-p1, -1.3*p2, -1.2*p3, -2.1*p4])

points2 = base_spline.Points
Wire = Draft.makeWire(points2)